/*
PAYMENTS API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package paymentsapi

import (
	"encoding/json"
)

// checks if the CreateUnzerConfigRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CreateUnzerConfigRequest{}

// CreateUnzerConfigRequest struct for CreateUnzerConfigRequest
type CreateUnzerConfigRequest struct {
	PublicKey string `json:"public_key"`
	PrivateKey string `json:"private_key"`
	ApiUrl string `json:"api_url"`
}

// NewCreateUnzerConfigRequest instantiates a new CreateUnzerConfigRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCreateUnzerConfigRequest(publicKey string, privateKey string, apiUrl string) *CreateUnzerConfigRequest {
	this := CreateUnzerConfigRequest{}
	this.PublicKey = publicKey
	this.PrivateKey = privateKey
	this.ApiUrl = apiUrl
	return &this
}

// NewCreateUnzerConfigRequestWithDefaults instantiates a new CreateUnzerConfigRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCreateUnzerConfigRequestWithDefaults() *CreateUnzerConfigRequest {
	this := CreateUnzerConfigRequest{}
	return &this
}

// GetPublicKey returns the PublicKey field value
func (o *CreateUnzerConfigRequest) GetPublicKey() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.PublicKey
}

// GetPublicKeyOk returns a tuple with the PublicKey field value
// and a boolean to check if the value has been set.
func (o *CreateUnzerConfigRequest) GetPublicKeyOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.PublicKey, true
}

// SetPublicKey sets field value
func (o *CreateUnzerConfigRequest) SetPublicKey(v string) {
	o.PublicKey = v
}

// GetPrivateKey returns the PrivateKey field value
func (o *CreateUnzerConfigRequest) GetPrivateKey() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.PrivateKey
}

// GetPrivateKeyOk returns a tuple with the PrivateKey field value
// and a boolean to check if the value has been set.
func (o *CreateUnzerConfigRequest) GetPrivateKeyOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.PrivateKey, true
}

// SetPrivateKey sets field value
func (o *CreateUnzerConfigRequest) SetPrivateKey(v string) {
	o.PrivateKey = v
}

// GetApiUrl returns the ApiUrl field value
func (o *CreateUnzerConfigRequest) GetApiUrl() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ApiUrl
}

// GetApiUrlOk returns a tuple with the ApiUrl field value
// and a boolean to check if the value has been set.
func (o *CreateUnzerConfigRequest) GetApiUrlOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ApiUrl, true
}

// SetApiUrl sets field value
func (o *CreateUnzerConfigRequest) SetApiUrl(v string) {
	o.ApiUrl = v
}

func (o CreateUnzerConfigRequest) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CreateUnzerConfigRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["public_key"] = o.PublicKey
	toSerialize["private_key"] = o.PrivateKey
	toSerialize["api_url"] = o.ApiUrl
	return toSerialize, nil
}

type NullableCreateUnzerConfigRequest struct {
	value *CreateUnzerConfigRequest
	isSet bool
}

func (v NullableCreateUnzerConfigRequest) Get() *CreateUnzerConfigRequest {
	return v.value
}

func (v *NullableCreateUnzerConfigRequest) Set(val *CreateUnzerConfigRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableCreateUnzerConfigRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableCreateUnzerConfigRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCreateUnzerConfigRequest(val *CreateUnzerConfigRequest) *NullableCreateUnzerConfigRequest {
	return &NullableCreateUnzerConfigRequest{value: val, isSet: true}
}

func (v NullableCreateUnzerConfigRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCreateUnzerConfigRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


